import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CooperateLog, CooperateLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商务合作留言记录
 */
export async function pageCooperateLog(params: CooperateLogParam) {
  const res = await request.get<ApiResult<PageResult<CooperateLog>>>(
    MODULES_API_URL + '/booking/cooperate-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商务合作留言记录列表
 */
export async function listCooperateLog(params?: CooperateLogParam) {
  const res = await request.get<ApiResult<CooperateLog[]>>(
    MODULES_API_URL + '/booking/cooperate-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商务合作留言记录
 */
export async function addCooperateLog(data: CooperateLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商务合作留言记录
 */
export async function updateCooperateLog(data: CooperateLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商务合作留言记录
 */
export async function removeCooperateLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商务合作留言记录
 */
export async function removeBatchCooperateLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商务合作留言记录
 */
export async function getCooperateLog(id: number) {
  const res = await request.get<ApiResult<CooperateLog>>(
    MODULES_API_URL + '/booking/cooperate-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
